         section code

         xdef mdinf

         include dev8_keys_qdos_io

mdinf
* * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                 get media info
* P Witte
* V0.03 - fixed bug to recognise ddl1 (see ***)
*
* input  : a0 = channel id
* return : a1 ->info (a6 rel)
*        : d0 = error, 1 or 2 (ddl)
*
* no other registeres affected
*
* At least 64 bytes required in buffer
*
regs     reg d1/d3
         movem.l regs,-(sp)
         moveq #-1,d3                        ;timeout
         moveq #0,d1
         move.l (a6),a1                      ;a1->buffer
         moveq #iof.xinf,d0                   ddl2 only!
         trap #4
         trap #3
         tst.l d0
         beq.s md_ddl2                       ;all ok ie: ddl2

         cmp.w #-15,d0                       *** prev cmp.w #-15: beq.s rts
         bne.s md_rts                        any other error is baad

dd1
         addq.l #2,a1                        ;leave room for length count
         moveq #iof.minf,d0                  ;md.inf
         trap #4
         trap #3
         tst.l d0
         bne.s md_rts

         move.l (a6),a1
         move.w d1,d3                        ;d3.w = good sectors
         swap d1                             ;d1.w = free sectors
         ext.l d1
         divu #3,d1                          ;allocation unit = 3 sectors
         move.l d1,ioi_free(a6,a1.l)
         ext.l d3
         divu #3,d3
         move.l d3,ioi_totl(a6,a1.l)
         move.w #1536,ioi_allc(a6,a1.l)      ;allocation unit size in bytes
         move.l #64,ioi_hdrl(a6,a1.l)        ;file header length
         move.b d0,ioi_rdon(a6,a1.l)         ;r-o status NI on ddl1
         move.b d0,ioi_remv(a6,a1.l)         ;wp NI on ddl1

dd1_1
         moveq #9,d3                         ;max name len (-1)
         lea.l 13(a1),a1                     ;point to end of name

dd1_loop
         subq.l #1,a1
         cmpi.b #' ',0(a6,a1.l)
         dbne d3,dd1_loop

dd1_2
         move.l (a6),a1
         addq.w #1,d3
         move.w d3,0(a6,a1.l)                actual name length

         moveq #1,d0                         level 1
         bra.s md_rts

md_ddl2
         moveq #2,d0                         level 2

md_rts
         movem.l (sp)+,regs
         rts

         end
