* Media information PWitte   August 7th 1992
* V0.03
* V0.04 - October 27th 2004 Special: MDALLOC(#ch) only
* V0.05, pjw, October 5th 2018: Added back MDFREE
* V0.06, pjw, April 6th 2019, temp fix for DOS on QPC2 (and 15/4 unfixed)
* V0.06, pjw, 2020 Mar 24, Special for Stats: Added back MDGOOD
* V0.07, pjw, 2021 Oct 27, Updated mdfree to return result in bytes
* V0.08, pjw, 2025 Feb 08, work-around to prevent overflow on large disks

        section code

        include dev8_keys_qdos_io
        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err

        xdef MDFSIZE,MDFREE,MDFHEAD,MDALLOC,MDGOOD

        xref channel
        xref getpars
        xref l2frtrd6,l2frtr


MDGOOD
        bsr.s common

        move.l ioi_totl(a6,a1.l),d6
        bra.s al2bts


MDFREE
        bsr.s common

        move.l ioi_free(a6,a1.l),d6

al2bts
         moveq #0,d1
         move.w ioi_allc(a6,a1.l),d1
         move.l d6,-(a7)
         bsr l2frtr             float and stack alloc

         move.l (a7)+,d6
         bsr l2frtrd6           float and stack no. sectors

         moveq #qa.mul,d0       alloc x sectors = bytes
         move.w qa.op,a2
         jsr (a2)

         bne.s ovfl

         move.w (a6,a1.l),6(a6,a1.l)
         move.l 2(a6,a1.l),8(a6,a1.l)
         addq.l #6,sb_arthp(a6)
         movea.l sb_arthp(a6),a1

         moveq #0,d0

ovfl
         rts

*
common
        bsr channel
        bne.s error

        bsr.s mdinf
        beq.s err

error
        addq.l #4,sp

err
        rts

MDFSIZE
        bsr channel
        bne.s err

        moveq #$16,d0                   get one long
        bsr getpars
        bne.s err

        move.l 0(a6,a1.l),d1            d1 = file length
        addq.l #4,sb_arthp(a6)

        bsr.s mdinf
        bne.s err

        add.l ioi_hdrl(a6,a1.l),d1      add file header length
        subq.l #1,d1

        move.w ioi_allc(a6,a1.l),d6
        divu d6,d1
        addq.l #1,d1
        mulu d1,d6

        bra l2frtrd6


MDFHEAD
        bsr.s common

        move.l ioi_hdrl(a6,a1.l),d6
        bra l2frtrd6

MDALLOC
        bsr.s common

        moveq #0,d6             can be > 32k
        move.w ioi_allc(a6,a1.l),d6
        bra l2frtrd6

*
mdinf
* * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                 get media info
*
* pjwitte 1994..2004+
* V0.01 DDL2+ only
*
* input  : a0 = channel id
* return : a1 ->info (a6 rel)
*        : d0 = error
*
* no other registeres affected
*
* 64 bytes required in buffer
*

         move.l (a6),a1         a1->buffer

         movem.l d1/d3,-(sp)

         moveq #-1,d3           timeout
         moveq #0,d1
         moveq #iof.xinf,d0     ddl2 only!
         trap #4                a6 rel
         trap #3

         movem.l (sp)+,d1/d3
         tst.l d0
         rts

*
         end
