* Media information PWitte   August 7th 1992
* V0.04, pjw, April 15th 2019, new layout; no functional changes
* V0.05, pjw, Sorted some stack mess!
* V0.06, pjw, 2021 Oct 27, Rationalised some more
* V0.07, pjw, 2025 Feb 08, work-around overflow of large disks
* V0.08, pjw, 2025 Mar 09, fixed stack problem in MDHEADR$

         section code

        include dev8_keys_qdos_io
        include dev8_keys_qdos_ioa
        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err

         xdef MDLEVEL
         xdef MDALLOC
         xdef MDFHEAD
         xdef MDGOOD
         xdef MDFREE
         xdef MDNAME
         xdef MDSTAT
         xdef MDREMV
         xdef getmd_info
         xdef ioclose
         xdef chop

         xref str2stk
         xref datad
         xref chan_get
         xref l2frtrd6,l2frtr
         xref mdinf
         xref ut_stos
         xref resrir

*
al2bts
         moveq #0,d1
         move.w ioi_allc(a6,a1.l),d1
         move.l d6,-(a7)
         bsr l2frtr             float and stack alloc

         move.l (a7)+,d6
         bsr l2frtrd6           float and stack no. sectors

         moveq #qa.mul,d0       alloc x sectors = bytes
         move.w qa.op,a2
         jsr (a2)

         bne.s ovfl

         move.w (a6,a1.l),6(a6,a1.l)
         move.l 2(a6,a1.l),8(a6,a1.l)
         addq.l #6,sb_arthp(a6)
         movea.l sb_arthp(a6),a1

         moveq #0,d0

ovfl
         rts

MDGOOD
         bsr.s getmd_info
         move.l ioi_totl(a6,a1.l),d6
         bra.s al2bts

MDFREE
         bsr.s getmd_info
         move.l ioi_free(a6,a1.l),d6
         bra.s al2bts

MDLEVEL
         bsr.s getmd_info
         move.l d0,d6
         bra.s intret

MDALLOC
         bsr.s getmd_info
         moveq #0,d6             can be > 32k
         move.w ioi_allc(a6,a1.l),d6
         bra l2frtrd6

MDFHEAD
         bsr.s getmd_info
         move.l ioi_hdrl(a6,a1.l),d6
         bra l2frtrd6

MDSTAT
         bsr.s getmd_info
         moveq #0,d6
         move.b ioi_rdon(a6,a1.l),d6
         bra.s flagret

MDREMV
         bsr.s getmd_info
         moveq #0,d6
         move.b ioi_remv(a6,a1.l),d6
         bra.s flagret

MDNAME
         bsr.s getmd_info

ret_ok
         moveq #0,d0

md_rts
         rts

*
flagret
         beq.s intret           0 or
         moveq #1,d6             1

intret
         moveq #2,d1            reserve 2 bytes
         bsr resrir
         move.w d6,0(a6,a1.l)   put int on stack
         moveq #ar.int,d4       tell SB int return
         bra.s ret_ok           done

*
getmd_info
         move.l sb_arthp(a6),d7 save current relative stack base

         cmpa.l a3,a5           any parameters?
         ble.s md_def
         btst #nt..hash,1(a6,a3.l) preceded by hash?
         bne.s md_1             yes, so check if open

         bsr ut_stos            no, get file name
         bne.s md_err           oops


         trap #4                not required if datad used!
         bra.s md_och           open channel

md_1
         bsr chan_get           returns clean ri.stack
         bne.s md_err

         moveq #-1,d6           flag don't close
         bra.s md_cho

md_def
         bsr datad              returns with a1->datad$ Not a6 rel!

md_och
         moveq #ioa.kdir,d3     file type is directory
         bsr.s chop             open directory
         bne.s md_err
         moveq #0,d6            flag: close after use

md_cho
         bsr mdinf              get media info
         tst.l d6
         beq.s mdc_c

         tst.l d0
         bra.s mdc_rts          flagged: dont close

mdc_c
         bsr.s ioclose

mdc_rts
         move.l d7,sb_arthp(a6) restore stack

         tst.l d0
         bmi.s md_err           dont return if error
         rts

md_err
         addq.l #4,sp           return to SB direct
         rts

ioclose
         movem.l d0/a1,-(sp)
         moveq #ioa.clos,d0
         trap #do.ioa
         movem.l (sp)+,d0/a1
         tst.l d0
         rts

*
chop
*        Smashes a1 (and a0 if call fails!)

         moveq #myself,d1       job id
         movea.l a1,a0
         moveq #ioa.open,d0
         trap #do.ioa
         tst.l d0
         rts


         end
